package xyz.playedu.api.service;

import xyz.playedu.api.domain.Department;
import com.baomidou.mybatisplus.extension.service.IService;
import xyz.playedu.api.exception.NotFoundException;

import java.util.List;
import java.util.Map;

/**
 * @author tengteng
 * @description 针对表【departments】的数据库操作Service
 * @createDate 2023-02-19 10:39:57
 */
public interface DepartmentService extends IService<Department> {

    List<Department> listByParentId(Integer id);

    List<Department> all();

    Department findOrFail(Integer id) throws NotFoundException;

    void deleteById(Integer id) throws NotFoundException;

    void update(Department department, String name, Integer parentId, Integer sort) throws NotFoundException;

    List<Integer> allIds();

    String compParentChain(Integer parentId) throws NotFoundException;

    String childrenParentChain(Department department);

    void create(String name, Integer parentId, Integer sort) throws NotFoundException;

    void remoteRelateUsersByDepId(Integer depId);

    List<Integer> getUserIdsByDepId(Integer depId);

    List<Integer> getCourseIdsByDepId(Integer depId);

    void changeParent(Integer id, Integer parentId, List<Integer> ids) throws NotFoundException;

    void resetSort(List<Integer> ids);

    Map<Integer, List<Department>> groupByParent();

    Map<Integer, String> id2name();

    Long total();
}
